
Foreman - Bug #1370

creating a machine always sets "owner = user"

12/05/2011 10:54 AM - Jan van Eldik

Status: Resolved   

Priority: Normal   

Assignee:    

Category:    

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

When creating a machine through the API, it seems the ownership is always

set to user issues the request, even though owner_id does not correspond

to this user.

In other words, when I use my "jveldik" account to register a new

machine in Foreman, and I specify "owner_id = 1" to set ownership to

the "admin" account, Foreman sets it to "jveldik" (owner_id = 6).

From the Foreman log file:

Processing HostsController#create (for 128.141.28.9 at 2011-12-05 16:40:46) [POST]

    Parameters: {"action"=>"create", "controller"=>"hosts", "host"=>{"subnet_id"=>"1", "name"=>"ja

nvm01", "architecture_id"=>"1", "mac"=>"00:15:5D:FF:48:A7", "domain_id"=>"1", "owner_id"=>"1", "ho

stgroup_id"=>"3", "ptable_id"=>"1", "sp_subnet_id"=>"1", "ip"=>"128.142.194.47", "environment_id"=

>"16", "model_id"=>"4", "operatingsystem_id"=>"3"}}

 From https://foreman.mydomain.org/hosts/janvm01.mydomain.org?format=json

{"host":{"subnet_id":1,"serial":null,"puppetproxy_id":null,"name":"janvm01.mydomain.org","managed"

:true,"last_report":null,"comment":null,"architecture_id":1,"created_at":"2011-12-05T15:43:47Z","s

p_mac":"","puppetmaster_name":"foreman.mydomain.org","image_file":null,"updated_at":"2011-12-05T15

:43:47Z","sp_name":"","mac":"00:15:5d:ff:48:a7","installed_at":null,"domain_id":1,"use_image":null

,"root_pass":"XXXXXXXXXXXXXXXXXXXXX","owner_id":6,"medium_id":6,"id":248,"hostgroup_id":3,"enabled

":true,"build":false,"ptable_id":1,"sp_subnet_id":1,"puppet_status":0,"last_freshcheck":null,"ip":

"128.142.194.47","environment_id":16,"source_file_id":null,"model_id":4,"environment":{"environmen

t":{"name":"production","id":16}},"sp_ip":"","disk":null,"owner_type":"User","operatingsystem_id":

3,"last_compile":null}}

 100% reproducible.

cheers, Jan

History

#1 - 12/20/2011 07:17 AM - Ohad Levy

looking at the code i find it strange, and it might be related to the fact that owner is a polymorphic relationship.

can you try changing the line (around 153 in my code) from

self.owner ||= User.current

 to

self.owner ||= User.current if owner_id.blank?

#2 - 01/01/2012 08:21 AM - Ohad Levy
https://foreman.mydomain.org/hosts/janvm01.mydomain.org?format=json


- Status changed from New to Resolved

since owner is a polymorphic attribute, i think you need to pass the owner_type as well in your API call.

Ohad

#3 - 01/11/2012 05:41 AM - Jan van Eldik

Hi Ohad,

OK, I will try adding the owner_type. But what should it be?

How can I find out the available types?

thanks, Jan

#4 - 01/11/2012 02:52 PM - Jan van Eldik

Hi,

Indeed, with "owner_type = User" the problem goes away, thanks for

the hint!

Are the owner_types enumerated somewhere?
